#ifdef __cplusplus

#define DllExport    __declspec( dllexport )

#include <windows.h>

//#define WORD unsigned short
//#define BYTE unsigned char


extern "C"
{
    // change Port: 0->278 1->378 2->3BC
    // return active Port-adr.
    // if you will only read the Port-adr., call argument > 2
    // default 0x378
    DllExport WORD  set_Port(BYTE);

    // read from RAM into internal buffer; range 1 .. 8000h
    // return numbers of readed bytes
    // or zero for an error
    DllExport WORD read_ram(WORD);

    // write buffer to RAM; return the last adr. of writing byte
    DllExport WORD write_ram();

    // return internal buffer-size
    DllExport WORD  get_bufsize();

    // read from file into internal buffer
    // 0 sign an error (or file is empty)
    DllExport WORD read_file(char*);

    // write internal buffer to given file(path)
    // an existing file will be overwritten
    // 0 sign an error
    DllExport WORD write_file(char*);
    
    // set speed-value in range of 1..255 (1=max speed)
    // the speed-value increase/decrease access to uC-board
    // return TRUE if changing successful
    DllExport BOOL set_delay(BYTE);

    //return speed-value
    DllExport BYTE get_delay();

    // return active chsum above the buffer
    DllExport WORD  get_chsum();

    // generate a short reset-pulse on the uboard
    DllExport void reset();
    
    // return DLL-version
    DllExport char* get_version();

    // return last error-string
    DllExport char* get_LastError(); 

    // set callback-pointer -> used in read_ram + write_ram
    // you can set callback in % with BYTE-argument
    // call: setCallback(NULL) (or without args) to disable this feature
    // Range: 1 -> 1%
    //        2 -> 2%
    //        3 -> 5%
    //        4 -> 10%
    //        5 -> 20%
    //        default 5%
    // NOTE: your function must be declared like this:
    //       void function_name(WORD act_Adr, WORD last_Adr);
    DllExport void setCallback(void (*call_back)(WORD,WORD)=NULL, BYTE=3);

}

/* code-example for WINDOWS
//global define
CProgressCtrl *pBulk=NULL;
//init this pointer e.g. in InitDialog()
//  m_progress.SetRange( 0, 100 );
//  m_progress.SetStep(1);
//  m_progress.SetPos(0);
//  pBulk=&m_progress;
//  setCallback(Call_Back);

//global function
void Call_Back(WORD pos, WORD buf_size)
{
    if (buf_size==0) return;
    float percent=0;
    if (pos==0)
    {
        pBulk->SetPos(0);
    }
    else
    {
        percent=float(pos*100/buf_size);
        pBulk->SetPos(UINT(percent));
    }
}
*/


#endif
